package clustering;

import java.io.Serializable;

public class KMeansState implements Cloneable, Serializable {

    public KMeansState() {
    }

    public KMeansState(Object[] data, int dataCount) {
        this.data = data;
        this.dataCount = dataCount;
    }

    public KMeansState(Object[] data, int dataCount, int clusterCount) {
        this.data = data;
        this.dataCount = dataCount;
        this.clusterCount = clusterCount;
    }

    public KMeansState(KMeansClustering kmc, Object[] data, int dataCount,
            int clusterCount) {
        this.data = data;
        this.dataCount = dataCount;
        this.clusterCount = clusterCount;
        this.kmc = kmc;
    }

    public Object[] kMeans;

    public int[] cluster;

    public int clusterCount = -1;

    public double validity = -1;

    public double objective = -1;

    public Object[] data;

    public int dataCount;

    public int minClusterCount = 2;

    public int maxClusterCount = -1;

    public double[] clusterCounts;

    public double[][] clusterSquaredDist;

    public transient KMeansClustering kmc;
    
    public double sumDist;

    public Object clone() {
        KMeansState state = null;
        try {
            state = (KMeansState) super.clone();
        } catch (CloneNotSupportedException e) {
            e.printStackTrace();
            state = new KMeansState(kmc, data, dataCount, clusterCount);
        }
        if (cluster != null) {
            state.cluster = new int[cluster.length];
            for (int i = 0; i < cluster.length; i++) {
                state.cluster[i] = cluster[i];
            }
        }
        state.validity = validity;
        state.objective = objective;
        state.sumDist=sumDist;
        return state;
    }
}
