/*
 * Created on Aug 13, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package pipes;

import java.util.NoSuchElementException;

import xxl.core.pipes.processors.SourceProcessor;
import xxl.core.pipes.sinks.Sink;
import xxl.core.pipes.sources.AbstractSource;
import xxl.core.pipes.sources.Source;
import xxl.core.pipes.sources.SourceIsClosedException;

/**
 * @author beringer
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public abstract class MultipleSource extends AbstractSource {

	protected class DummySource extends AbstractSource {
		public DummySource(SourceProcessor proc) {
			super(proc);
		}
		public Object next() throws NoSuchElementException {
			return null;
		}
        public void open() throws SourceIsClosedException {
            MultipleSource.this.open();
        }
        public void close() {
            MultipleSource.this.close();
        }
	}

	protected int[] outputIDs;
	protected Source[] sources;
	protected int count;
    
    public MultipleSource(int count, long period) {
        super(period);
        this.count= count;
        outputIDs=new int[count];
        sources= new Source[count];
        for (int i= 0; i < count; i++) {
            outputIDs[i]=i;
            sources[i]= new DummySource(null);
        }
        //processor.registerSource(this);
    }

	public MultipleSource(int[] outputIDs, long period) {
		super(period);
		this.outputIDs= outputIDs;
		count= outputIDs.length;
		sources= new Source[count];
		for (int i= 0; i < count; i++) {
			sources[i]= new DummySource(null);
		}
		//processor.registerSource(this);
	}

	public MultipleSource(int[] IDs, SourceProcessor proc) {
		super(proc);
		this.outputIDs= IDs;
		count= IDs.length;
		sources= new Source[count];
		for (int i= 0; i < count; i++) {
			sources[i]= new DummySource(null);
		}
		//processor.registerSource(this);
	}

	public boolean subscribe(Sink sink, int inputID) throws SourceIsClosedException {
		boolean val= true;
		for (int i= 0; i < count; i++) {
			val= val && sources[i].subscribe(sink, inputID);
		}
		return val;
	}

	public boolean subscribe(Sink sink, int inputID, int outputID) throws SourceIsClosedException {
		boolean val= true;
		//super.subscribe(sink, inputID);
		for (int i= 0; i < count; i++) {
			if (outputID == outputIDs[i])
				val= val && sources[i].subscribe(sink, inputID);
		}
		return val;
	}

	public boolean unsubscribe(Sink sink, int inputID) throws SourceIsClosedException {
		boolean val= true;
		for (int i= 0; i < count; i++) {
			val= val || sources[i].unsubscribe(sink, inputID);
		}
		return val;
	}

	public boolean unsubscribe(Sink sink, int inputID, int outputID)
		throws SourceIsClosedException {
		boolean val= false;
		//super.subscribe(sink, inputID);
		for (int i= 0; i < count; i++) {
			if (outputID == outputIDs[i])
				val= val || sources[i].unsubscribe(sink, inputID);
		}
		return val;
	}

	public void pause(Sink sink, int inputID) throws SourceIsClosedException {
		for (int i= 0; i < count; i++) {
			sources[i].pause(sink, inputID);
		}
	}

	public void pause(Sink sink, int inputID, int outputID) throws SourceIsClosedException {
		for (int i= 0; i < count; i++) {
			if (outputID == outputIDs[i])
				sources[i].pause(sink, inputID);
		}
	}

	public void resume(Sink sink, int inputID) throws SourceIsClosedException {
		for (int i= 0; i < count; i++) {
			sources[i].resume(sink, inputID);
		}
	}

	public void resume(Sink sink, int inputID, int outputID) throws SourceIsClosedException {
		for (int i= 0; i < count; i++) {
			if (outputID == outputIDs[i])
				sources[i].resume(sink, inputID);
		}
	}

	public int transfer(Object ob) {
        if (ob==null) return 0;
		Object[] obs= (Object[]) ob;
		int c= 0;
        int len=obs.length;
        len=Math.min(len,count);
		for (int i= 0; i < len; i++) {
			c += sources[i].transfer(obs[i]);
		}
		return c;
	}

	public int transfer(Object ob, int outputID) {
		int c= 0;
		for (int i= 0; i < count; i++) {
			if (outputID == outputIDs[i])
				c += sources[i].transfer(ob);
		}
		return c;
	}

}
