/*
 * Created on 03.07.2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code Template
 */
package clustering;


/**
 * @author beringer
 */
public class FuzzyKMedian extends FuzzyKMeans {

	double[][] distanceArray;
	int dataCount;

	protected static FuzzyAverage getMeansFunction() {
		return new FuzzyAverage() {
			public Object average(FuzzyKMeansClustering fkm,Object[] obs,int len,double[][] cluster,int clusterNr,Object mean){
				
				//Object mean= objects[5];
				Distance dist= fkm.getDistance();
				double[] sumDist= new double[len];
				double val;
				for (int i= 0; i < len - 1; i++) {
					for (int j= i + 1; j < len; j++) {
						val= dist.distance(obs[i], obs[j]);
						sumDist[i] += val * cluster[j][clusterNr];
						sumDist[j] += val * cluster[i][clusterNr];
					}
				}
				int minIndex= 0;
				val= sumDist[0];
				for (int i= 1; i < len; i++) {
					if (sumDist[i] < val) {
						val= sumDist[i];
						minIndex= i;
					}
				}
				return obs[minIndex];

			}
		};
	}

	public FuzzyKMedian(
		double[][] distanceArray,
		int dataCount,
		double fuzzifier,
		double noiseDistance) {
		super(
			KMedian.getDistance(distanceArray),
			fuzzifier,
			FuzzyKMeans.OBJECTIVE,
			FuzzyKMeans.SEPARATION,
            FuzzyKMeansUtils.INITALIZE,
			KMedian.getCopyObjectFunction(),
			getMeansFunction(),
			noiseDistance);
		this.distanceArray= distanceArray;
		this.dataCount= dataCount;

	}

	public FuzzyKMedian(double[][] distanceArray, int dataCount, double fuzzifier) {
		super(
			KMedian.getDistance(distanceArray),
			fuzzifier,
			FuzzyKMeans.OBJECTIVE,
			FuzzyKMeans.SEPARATION,
            FuzzyKMeansUtils.INITALIZE,
			KMedian.getCopyObjectFunction(),
			getMeansFunction());
		this.distanceArray= distanceArray;
		this.dataCount= dataCount;
	}

	/* (non-Javadoc)
	 * @see xxl.datamining.KMeans#initialize(java.lang.Object[], int, java.lang.Object[], int)
	 */
	public void initialize(Object[] kmeans, int clusterCount, Object[] data, int dataCount) {
		for (int i= 0; i < clusterCount; i++) {
			kmeans[i]= data[i];
		}
	}

	/* (non-Javadoc)
	 * @see xxl.datamining.KMeans#computeSquaredDistance(java.lang.Object, java.lang.Object)
	 */
	protected double squaredDistance(Object d1, Object d2) {
		double res= distance(d1, d2);
		return res * res;
	}

	protected double distance(Object d1, Object d2) {
		int i1= ((Integer) d1).intValue();
		int i2= ((Integer) d2).intValue();
		if (i1 == i2)
			return 0.0;
		if (i1 < i2) {
			int help= i2;
			i2= i1;
			i1= help;
		}
		return distanceArray[i1][i2];
	}

	public FuzzyKMeansState invokeKMedian(int clusterCount, double epsilon) {
		Object[] data= new Object[dataCount];
		for (int i= 0; i < dataCount; i++)
			data[i]= new Integer(i);
		return invokeFuzzyKMeans(data, dataCount, clusterCount, epsilon);
	}

	public Object copyObject(Object ob1, Object ob2) {
		ob2= ob1;
		return ob2;
	}

}
